/*! \file ControlInput.h 
 *  \brief: header file for triavertexinput object
 */

#ifndef _CONTROLINPUT2_H_
#define _CONTROLINPUT2_H_

/*Headers:*/
#include "./Input.h"
class Gauss;
class ElementInput;

class ControlInput: public Input{

	public:
		int            control_id;
		int            enum_type;
		int            layout_enum;
		ElementInput *gradient;
		ElementInput *maxvalues;
		ElementInput *minvalues;
		ElementInput *savedvalues;
		ElementInput *values;

		/*ControlInput constructors, destructors: {{{*/
		ControlInput();
		ControlInput(int nbe, int nbv,int input_layout_enum,int interp,int id);
		~ControlInput();
		/*}}}*/
		/*Object virtual functions definitions:{{{ */
		Input* copy();
		void    DeepEcho();
		void    Echo();
		int     Id(); 
		void    Marshall(char** pmarshalled_data,int* pmarshalled_data_size, int marshall_direction);
		int     ObjectEnum();
		/*}}}*/
		void SetInput(Input* in_input){_error_("not impelemented");};
		void SetInput(Input* in_input,int timeoffset){_error_("not impelemented");};
		ElementInput* GetInput(const char* data);
		void SetControl(int interp,int numindices,int* indices,IssmDouble* values_in,IssmDouble* values_min,IssmDouble* values_max);
		void SetGradient(int interp,int numindices,int* indices,IssmDouble* values_in);
		void SetGradient(int interp,int numindices,int* indices,IssmDouble* values_in,int n);
		TriaInput* GetTriaInput();
		PentaInput* GetPentaInput();
};
#endif  /* _CONTROLINPUT_H */
